extern crate session_types;
use session_types::*;


type Srv = Offer<
    Recv<i64, Recv<i64, Send<i64, Eps>>>,
    Recv<i64, Send<i64, Eps>>
>;

type NegCli = <Srv as HasDual>::Dual;


pub(crate) fn server(c: Chan<(), Srv>) {
    offer! { c,
            ADD => {
                let (c2, n) = c.recv();
                let (c, m) = c2.recv();
                c.send(n + m).close()
            },
            NEGATE => {
                let (c, n) = c.recv();
                c.send(-n).close()
            }
        }
}



pub(crate) fn neg_client(c: Chan<(), NegCli>) {
    let (c2, n) = c.sel1().send(42).send(42).recv();
    //let (c2, n) = c.sel2().send(42).recv();
    println!("{}", n);
    c2.close();
}
